/**************************************************************** 
 * Description: 洛谷 P1008  三连击
 * Author: Alex Li
 * Date: 2024-01-22 14:37:33
 * LastEditTime: 2024-01-22 14:41:12
****************************************************************/

/***************************************************************
 * 这段代码通过迭代查找所有可能的三位数a，然后计算出2倍的b和3倍的c。
 * 通过一个辅助数组n来跟踪哪些数字（1-9）已经在这三个数字中使用过。
 * 如果所有的数字都恰好被使用了一次（使得数组n中1到9的总和等于9），
 * 那么这组数字（a, b, c）就是一个有效的解决方案，随后将其输出。 * 
*/
#include<iostream>
using namespace std;

int main(){
    int a, b, c, s, h;
    int n[10]; // 定义一个数组n用来标记数字1到9的使用情况

    for(a = 123; a * 3 < 988; a++){ // 从123开始循环，因为最大的三位数是987，它的1/3是329
        for(h = 1; h < 10; h++){
            n[h] = 0; // 初始化数组n，将1到9的使用标记为未使用（0）
        }
        // 分解数字a的每一位，并在数组n中标记为已使用（1）
        n[a / 100] = 1;       // 百位
        n[a / 10 % 10] = 1;   // 十位
        n[a % 10] = 1;        // 个位

        b = a * 2; // 计算第二个数b，是a的两倍
        // 分解数字b的每一位，并在数组n中标记为已使用
        n[b / 100] = 1;
        n[b / 10 % 10] = 1;
        n[b % 10] = 1;

        c = a * 3; // 计算第三个数c，是a的三倍
        // 分解数字c的每一位，并在数组n中标记为已使用
        n[c / 100] = 1;
        n[c / 10 % 10] = 1;
        n[c % 10] = 1;

        for(s = 0, h = 1; h < 10; h++){
            s += n[h]; // 统计已使用的数字数量
        }

        if(s == 9){ // 如果所有的数字（1-9）都恰好用了一次
            cout << a << ' ' << b << ' ' << c << endl; // 输出这三个数
        }
    }
    return 0;
}
